﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using log4net;

namespace RefactoringExamples
{
    class Program
    {


        static void Main(string[] args)
        {
            //String s = "Anders";
            //AssignmentToParameters(s);
            //Console.WriteLine(s);

            //IEnumerable<string> allLines = GetAllLines(@"c:/temp/file.txt");
            //Console.WriteLine(String.Join("\n", allLines));

            //Person p1 = new Person(1) { Type = "Teacher", Name = "Anders" };
            //Console.WriteLine(p1);
            LoopToException();
        }

        static void AssignmentToParameters(String str)
        {
            str = str + "abc";
            Console.WriteLine(str);
        }

        static double Area(double radius)
        {
            return 3.14159265 * radius * radius;
        }

        static IList<string> GetAllLines(String filename)
        {
            IList<String> result = new List<string>();
            using (StreamReader reader = new StreamReader(filename))
            {
                String line;
                while ((line = reader.ReadLine()) != null)
                {
                    Debug.Assert(line != null);
                    result.Add(line);
                }
            }
            return result;
        }

        static void Logging()
        {
            ILog logger = LogManager.GetLogger("someName");
        }

        static void LoopToException()
        {
            IList<String> lines = GetAllLines(@"c:/temp/file.txt");
            int index = 0;
            try { 
            while (true)
            {
                String str = lines[index];
                Console.WriteLine(str);
                index++;
            }
            }
            catch (ArgumentOutOfRangeException) { }

        }

        
    }

    class Person
    {
        public Person(int id)
        {
            Id = id;
        }

        public String Name { get; set; }
        public String Type { get; set; }

        public int Id { get; private set; }

        public override string ToString()
        {
            if (Type == "Student")
            {
                return "Student " + Name;
            }
            return "Teacher " + Name;
        }
    }
}
